EXCEPTION_MAXIMUM_PARAMETERS         	= 15
EXIT_PROCESS_DEBUG_EVENT             	= 5
INFINITE                             		= -1
EXCEPTION_DEBUG_EVENT                equ 1
CREATE_THREAD_DEBUG_EVENT            equ 2
CREATE_PROCESS_DEBUG_EVENT           equ 3
EXIT_THREAD_DEBUG_EVENT              equ 4
EXIT_PROCESS_DEBUG_EVENT             equ 5
LOAD_DLL_DEBUG_EVENT                 equ 6
UNLOAD_DLL_DEBUG_EVENT               equ 7
OUTPUT_DEBUG_STRING_EVENT            equ 8
RIP_EVENT                            equ 9

CONTEXT_i386              		= 00010000h
CONTEXT_i486              		= 00010000h
CONTEXT_CONTROL           		= CONTEXT_i386 OR 00000001h
CONTEXT_INTEGER           		= CONTEXT_i386 OR 00000002h
CONTEXT_SEGMENTS          		= CONTEXT_i386 OR 00000004h
CONTEXT_FLOATING_POINT    	= CONTEXT_i386 OR 00000008h
CONTEXT_DEBUG_REGISTERS   	= CONTEXT_i386 OR 00000010h
CONTEXT_FULL              		= CONTEXT_CONTROL OR CONTEXT_INTEGER OR CONTEXT_SEGMENTS

SIZE_OF_80387_REGISTERS   equ 80
MAXIMUM_SUPPORTED_EXTENSION          equ 512

DBG_CONTINUE                         equ 00010002h
DBG_TERMINATE_THREAD                 equ 40010003h
DBG_TERMINATE_PROCESS                equ 40010004h
DBG_CONTROL_C                        equ 40010005h
DBG_CONTROL_BREAK                    equ 40010008h
DBG_EXCEPTION_NOT_HANDLED            equ 80010001h

IMAGE_DIRECTORY_ENTRY_EXPORT                equ  0
IMAGE_DIRECTORY_ENTRY_IMPORT                =  1
IMAGE_DIRECTORY_ENTRY_RESOURCE              equ  2
IMAGE_DIRECTORY_ENTRY_EXCEPTION             equ  3
IMAGE_DIRECTORY_ENTRY_SECURITY              equ  4
IMAGE_DIRECTORY_ENTRY_BASERELOC             equ  5
IMAGE_DIRECTORY_ENTRY_DEBUG equ  6
IMAGE_DIRECTORY_ENTRY_COPYRIGHT             equ  7
IMAGE_DIRECTORY_ENTRY_GLOBALPTR             equ  8
IMAGE_DIRECTORY_ENTRY_TLS   equ  9
IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG           equ 10
IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT          equ 11
IMAGE_DIRECTORY_ENTRY_IAT   equ 12
IMAGE_NUMBEROF_DIRECTORY_ENTRIES            = 16
IMAGE_SIZEOF_SHORT_NAME equ 8
IMAGE_BITMAP                equ 0
IMAGE_ICON                  equ 1
IMAGE_CURSOR                equ 2
IMAGE_ENHMETAFILE           equ 3
PROCESSOR_INTEL_386         equ 386
PROCESSOR_INTEL_486         equ 486
PROCESSOR_INTEL_PENTIUM     equ 586
PROCESSOR_MIPS_R4000        equ 4000
PROCESSOR_ALPHA_21064       equ 21064

IMAGE_DOS_SIGNATURE equ 5A4Dh      
IMAGE_OS2_SIGNATURE equ 454Eh      
IMAGE_OS2_SIGNATURE_LE equ 454Ch      
IMAGE_VXD_SIGNATURE equ 454Ch      
IMAGE_NT_SIGNATURE equ 00004550h  
IMAGE_SIZEOF_FILE_HEADER equ 20
IMAGE_FILE_RELOCS_STRIPPED equ 0001h  
IMAGE_FILE_EXECUTABLE_IMAGE equ 0002h  
IMAGE_FILE_LINE_NUMS_STRIPPED equ 0004h  
IMAGE_FILE_LOCAL_SYMS_STRIPPED equ 0008h  
IMAGE_FILE_AGGRESIVE_WS_TRIM equ 0010h  
IMAGE_FILE_LARGE_ADDRESS_AWARE equ 0020h  
IMAGE_FILE_BYTES_REVERSED_LO equ 0080h  
IMAGE_FILE_32BIT_MACHINE equ 0100h  
IMAGE_FILE_DEBUG_STRIPPED equ 0200h  
IMAGE_FILE_REMOVABLE_RUN_FROM_SWAP equ 0400h  
IMAGE_FILE_NET_RUN_FROM_SWAP equ 0800h  
IMAGE_FILE_SYSTEM equ 1000h  
IMAGE_FILE_DLL equ 2000h  
IMAGE_FILE_UP_SYSTEM_ONLY equ 4000h  
IMAGE_FILE_BYTES_REVERSED_HI equ 8000h  
IMAGE_FILE_MACHINE_UNKNOWN equ 0
IMAGE_FILE_MACHINE_I386 equ 014ch  
IMAGE_FILE_MACHINE_R3000 equ 0162h  
IMAGE_FILE_MACHINE_R4000 equ 0166h  
IMAGE_FILE_MACHINE_R10000 equ 0168h  
IMAGE_FILE_MACHINE_WCEMIPSV2 equ 0169h  
IMAGE_FILE_MACHINE_ALPHA equ 0184h  
IMAGE_FILE_MACHINE_POWERPC equ 01F0h  
IMAGE_FILE_MACHINE_SH3 equ 01a2h  
IMAGE_FILE_MACHINE_SH3E equ 01a4h  
IMAGE_FILE_MACHINE_SH4 equ 01a6h  
IMAGE_FILE_MACHINE_ARM equ 01c0h  
IMAGE_FILE_MACHINE_THUMB equ 01c2h
IMAGE_FILE_MACHINE_IA64 equ 0200h  
IMAGE_FILE_MACHINE_MIPS16 equ 0266h  
IMAGE_FILE_MACHINE_MIPSFPU equ 0366h  
IMAGE_FILE_MACHINE_MIPSFPU16 equ 0466h  
IMAGE_FILE_MACHINE_ALPHA64 equ 0284h  
IMAGE_FILE_MACHINE_AXP64 equ IMAGE_FILE_MACHINE_ALPHA64
IMAGE_SIZEOF_ROM_OPTIONAL_HEADER equ 56
IMAGE_SIZEOF_STD_OPTIONAL_HEADER equ 28
IMAGE_SIZEOF_NT_OPTIONAL32_HEADER equ 224
IMAGE_SIZEOF_NT_OPTIONAL64_HEADER equ 240
IMAGE_NT_OPTIONAL_HDR32_MAGIC equ 10bh
IMAGE_NT_OPTIONAL_HDR64_MAGIC equ 20bh
IMAGE_ROM_OPTIONAL_HDR_MAGIC equ 107h
IMAGE_SUBSYSTEM_UNKNOWN equ 0   
IMAGE_SUBSYSTEM_NATIVE equ 1   
IMAGE_SUBSYSTEM_WINDOWS_GUI equ 2   
IMAGE_SUBSYSTEM_WINDOWS_CUI equ 3   
IMAGE_SUBSYSTEM_OS2_CUI equ 5   
IMAGE_SUBSYSTEM_POSIX_CUI equ 7   
IMAGE_SUBSYSTEM_NATIVE_WINDOWS equ 8   
IMAGE_SUBSYSTEM_WINDOWS_CE_GUI equ 9

SECTION_QUERY                        equ 1h
SECTION_MAP_WRITE                    equ 2h
SECTION_MAP_READ                     equ 4h
SECTION_MAP_EXECUTE                  equ 8h
SECTION_EXTEND_SIZE                  equ 10h
SECTION_ALL_ACCESS                   equ STANDARD_RIGHTS_REQUIRED OR SECTION_QUERY OR SECTION_MAP_WRITE OR SECTION_MAP_READ OR SECTION_MAP_EXECUTE OR SECTION_EXTEND_SIZE
FILE_MAP_COPY                        equ SECTION_QUERY
FILE_MAP_WRITE                       equ SECTION_MAP_WRITE
FILE_MAP_READ                        equ SECTION_MAP_READ
FILE_MAP_ALL_ACCESS                  equ SECTION_ALL_ACCESS

PAGE_NOACCESS             equ 1
PAGE_READONLY             equ 2
PAGE_READWRITE            equ 4
PAGE_WRITECOPY            equ 8
PAGE_EXECUTE              equ 10h
PAGE_EXECUTE_READ         equ 20h
PAGE_EXECUTE_READWRITE    equ 40h
PAGE_EXECUTE_WRITECOPY    equ 80h
PAGE_GUARD                equ 100h
PAGE_NOCACHE              equ 200h

struct FLOATING_SAVE_AREA
  ControlWord   dd      ?
  StatusWord    dd      ?
  TagWord       dd      ?
  ErrorOffset   dd      ?
  ErrorSelector dd      ?
  DataOffset    dd      ?
  DataSelector  dd      ?
  RegisterArea  db  80	dup(?);SIZE_OF_80387_REGISTERS dup(?)
  Cr0NpxState   dd      ?
ends

struct CONTEXT
  ContextFlags  dd      ?
  iDr0          dd      ?
  iDr1          dd      ?
  iDr2          dd      ?
  iDr3          dd      ?
  iDr6          dd      ?
  iDr7          dd      ?
  FloatSave     FLOATING_SAVE_AREA
  regGs         dd      ?
  regFs         dd      ?
  regEs         dd      ?
  regDs  	dd      ?
  
  regEdi        dd      ?
  regEsi        dd      ?
  regEbx        dd      ?
  regEdx        dd      ?
  regEcx        dd      ?
  regEax        dd      ?
  regEbp        dd      ?
  regEip        dd      ?
  regCs         dd      ?
  regFlag       dd      ?
  regEsp        dd      ?
  regSs         dd      ?
  ExtendedRegisters db MAXIMUM_SUPPORTED_EXTENSION dup(?)
ends

struct EXIT_PROCESS_DEBUG_INFO
	dwExitCode  dd      ?
ends

struct 	EXCEPTION_RECORD
	ExceptionCode         		dd   ?
	ExceptionFlags        	dd   ?
	pExceptionRecord      	dd   ?
	ExceptionAddress      	dd   ?
	NumberParameters      	dd   ?
	ExceptionInformation  	dd 	 EXCEPTION_MAXIMUM_PARAMETERS dup (?)
ends

struct	EXCEPTION_DEBUG_INFO
	pExceptionRecord  	EXCEPTION_RECORD
	dwFirstChance     	dd      ?
ends

struct 	DEBUG_EVENT
	dwDebugEventCode  	dd       ?
	dwProcessId       	dd       ?
	dwThreadId        	dd       ?
	union
		ExitProcess       	EXIT_PROCESS_DEBUG_INFO 
		Exception         		EXCEPTION_DEBUG_INFO
		
	ends
ends

;struct	DEBUGSTRUCT
;	Exception         		EXCEPTION_DEBUG_INFO <{?,?,?,?,?,EXCEPTION_MAXIMUM_PARAMETERS dup(?)},?>
;	CreateThread      	CREATE_THREAD_DEBUG_INFO <?,?,?>
;	CreateProcessInfo 	CREATE_PROCESS_DEBUG_INFO <?,?,?,?,?,?,?,?,?,?>
;	ExitThread        	EXIT_THREAD_DEBUG_INFO <?>
;	ExitProcess       	EXIT_PROCESS_DEBUG_INFO <?>
;	LoadDll           		LOAD_DLL_DEBUG_INFO <?,?,?,?,?,?>
;	UnloadDll         		UNLOAD_DLL_DEBUG_INFO <?>
;	DebugString       	OUTPUT_DEBUG_STRING_INFO <?,?,?>
;	RipInfo           		RIP_INFO <?,?>
;ends

struct	IMAGE_DATA_DIRECTORY
  VirtualAddress    	dd      ?
  isize             	dd      ?
ends

struct	IMAGE_OPTIONAL_HEADER32
  Magic                         	dw       ?
  MajorLinkerVersion            db       ?
  MinorLinkerVersion            db       ?
  SizeOfCode                    	dd      ?
  SizeOfInitializedData        dd      ?
  SizeOfUninitializedData     dd      ?
  AddressOfEntryPoint          	dd      ?
  BaseOfCode                    	dd      ?
  BaseOfData                    	dd      ?
  ImageBase                     	dd      ?
  SectionAlignment              	dd      ?
  FileAlignment                 	dd      ?
  MajorOperatingSystemVersion   dw       ?
  MinorOperatingSystemVersion   dw       ?
  MajorImageVersion             dw       ?
  MinorImageVersion             dw       ?
  MajorSubsystemVersion       dw       ?
  MinorSubsystemVersion       dw       ?
  Win32VersionValue            dd      ?
  SizeOfImage                   	dd      ?
  SizeOfHeaders                 	dd      ?
  CheckSum                      	dd      ?
  Subsystem                     	dw       ?
  DllCharacteristics            dw       ?
  SizeOfStackReserve            dd      ?
  SizeOfStackCommit             dd      ?
  SizeOfHeapReserve             dd      ?
  SizeOfHeapCommit              dd      ?
  LoaderFlags                   	dd      ?
  NumberOfRvaAndSizes           dd      ?
  DataDirectory                 	rb		sizeof.IMAGE_DATA_DIRECTORY*IMAGE_NUMBEROF_DIRECTORY_ENTRIES	
ends

struct	IMAGE_FILE_HEADER
  Machine               		dw    ?
  NumberOfSections      	dw    ?
  TimeDateStamp         	dd   ?
  PointerToSymbolTable  	dd   ?
  NumberOfSymbols       	dd   ?
  SizeOfOptionalHeader  	dw    ?
  Characteristics       	dw    ?
ends

struct 	IMAGE_NT_HEADERS
  Signature         	dd  ?
  FileHeader       	IMAGE_FILE_HEADER
  OptionalHeader 	IMAGE_OPTIONAL_HEADER32
ends

struct	IMAGE_DOS_HEADER
  e_magic           dw      ?
  e_cblp            dw      ?
  e_cp              dw      ?
  e_crlc            dw      ?
  e_cparhdr         dw      ?
  e_minalloc        dw      ?
  e_maxalloc        dw      ?
  e_ss              dw      ?
  e_sp              dw      ?
  e_csum            dw      ?
  e_ip              dw      ?
  e_cs              dw      ?
  e_lfarlc          dw      ?
  e_ovno            dw      ?
  e_res             dw   4 dup(?)
  e_oemid           dw      ?
  e_oeminfo         dw      ?
  e_res2            dw  10 dup(?)
  e_lfanew          dd      ?
ends

struct	IMAGE_IMPORT_DESCRIPTOR
	;union
		;Characteristics 		dd      ?
		OriginalFirstThunk 	dd   	?
	 ;ends
	 TimeDateStamp 			dd    ?
	ForwarderChain 			dd   ?
	Name1 					dd            ?
	FirstThunk 				dd       ?
ends

struct	IMAGE_EXPORT_DIRECTORY
  Characteristics          		dd      ?
  TimeDateStamp             		dd      ?
  MajorVersion              		dw       ?
  MinorVersion             		dw       ?
  nName                     			dd      ?
  nBase                    			dd      ?
  NumberOfFunctions         	dd      ?
  NumberOfNames             		dd      ?
  AddressOfFunctions        	dd      ?
  AddressOfNames            		dd      ?
  AddressOfNameOrdinals     	dd      ?
ends

struct 	IMAGE_SECTION_HEADER
    Name1 db IMAGE_SIZEOF_SHORT_NAME dup(?)
    ;union
        PhysicalAddress dd  ?
        ;VirtualSize dd      ?
    ;ends
    VirtualAddress dd       ?
    SizeOfRawData dd        ?
    PointerToRawData dd     ?
    PointerToRelocations dd ?
    PointerToLinenumbers dd ?
    NumberOfRelocations dw  ?
    NumberOfLinenumbers dw  ?
    Characteristics dd      ?
ends

