format PE GUI 4.0
stack	$00100000
heap	$00100000

include '%fasminc%\win32axp.inc'
include '%fasminc%\ENCODING\WIN1251.INC'
include '%fasminc%\macro\masm.inc'
include	'include\macro.inc'
include	'include\debug.inc'

IDI_TRAY		=	0
WM_SHELLNOTIFY 	=	WM_USER+5

ID_FILE			=	100

ID_OPEN			=	200
ID_GO			=	201

ID_TEST			=	300
ID_START		=	301
ID_EXIT			=	302
ID_CLEAR		=	303

ID_LOG			=	400

section '.data' data readable writeable

	AppName			db	'AntiCD',0
	ExeFilter		db 	"Exe Files(*.exe)",0,"*.exe",0
	;Patch			db	'1'
	
	;rec
	lpRootPathName	db	'e:\',0
	
	
section '.bss' readable writeable
	
	hInstance		dd	?
	hIcon			dd	?
	
	note 			NOTIFYICONDATA
	
	buffer			rb 512
	ofn				OPENFILENAME
	
	exename			rb	512
	command			rb	512
	
	ProcessInfo		PROCESS_INFORMATION
	StartInfo		STARTUPINFO
	
	NumberOfBytesRead	dd	?
	istest			dd	?
	
	buf				rb	512
	
	;rec
	lpVolumeNameBuffer	rb	512
	lpVolumeSerialNumber	rb	512
	lpMaximumComponentLength	rb	512
	lpFileSystemFlags			rb	512
	lpFileSystemNameBuffer		rb	512
	
	
section '.code' code readable executable

	start:
	;invoke	GetVolumeInformation,lpRootPathName,lpVolumeNameBuffer,512,lpVolumeSerialNumber,\
	;	lpMaximumComponentLength,lpFileSystemFlags,lpFileSystemNameBuffer,512
	invoke	GetVersion
	and		eax,$80000000
	je		@f
	invoke	MessageBoxA,0,"Sorry WIN2K\WINXP only :-(",AppName,MB_OK
	invoke	ExitProcess,0
	@@:
	invoke	GetModuleHandleA,0
	mov	[hInstance],eax
	invoke	DialogBoxParam,eax,37,HWND_DESKTOP,DialogProc,0
	invoke	ExitProcess,0
	
	proc DialogProc hwnddlg,msg,wparam,lparam
		push	ebx esi edi
		cmp	[msg],WM_SIZE
		je	.wmsize
		cmp	[msg],WM_SHELLNOTIFY
		je	.wmshellnotify
		cmp	[msg],WM_INITDIALOG
		je	.wminitdialog
		cmp	[msg],WM_COMMAND
		je	.wmcommand
		cmp	[msg],WM_CLOSE
		je	.wmclose
		xor	eax,eax
		jmp	.finish
		
		.wmcommand:
		cmp	[wparam],BN_CLICKED shl 16 + ID_START
		je	.start
		cmp	[wparam],BN_CLICKED shl 16 + ID_TEST
		je	.test
		cmp	[wparam],BN_CLICKED shl 16 + ID_EXIT
		je	.wmclose
		cmp	[wparam],BN_CLICKED shl 16 + ID_CLEAR
		je	.wmclear
		cmp	[wparam],BN_CLICKED shl 16 + ID_OPEN
		jne	.processed
		mov	[buffer],0
		mov	[ofn.lStructSize],sizeof.OPENFILENAME
		mov	[ofn.lpstrFilter],ExeFilter
		mov	[ofn.lpstrFile],buffer
		mov	[ofn.nMaxFile],512
		m2m	[ofn.hwndOwner],[hwnddlg]
		mov	[ofn.Flags],OFN_FILEMUSTEXIST + OFN_PATHMUSTEXIST + \
			OFN_LONGNAMES + OFN_EXPLORER or OFN_HIDEREADONLY
		invoke GetOpenFileName, ofn
		.if	eax<>0
			invoke	SetDlgItemText,[hwnddlg],ID_FILE,buffer
		.endif
		jmp	.processed
		
		.start:
		mov	[istest],0
		jmp	@f
		.test:
		mov	[istest],1
		@@:
		invoke	GetDlgItemText,[hwnddlg],ID_FILE,exename,512
		mov	al,[exename]
		.if	al = 0
			invoke	SendDlgItemMessage,[hwnddlg],ID_LOG,LB_ADDSTRING,0,"File is not chose"
		.else
			stdcall	Inject,exename,[istest]
			;invoke	WinExec,"regedit /s gta2.reg",SW_MINIMIZE
		.endif
		jmp	.processed
		
		.wmclear:
		invoke	SendDlgItemMessage,[hwnddlg],ID_LOG,LB_RESETCONTENT,0,0
		jmp	.processed	
		
		.wmsize:
		cmp	[wparam],SIZE_MINIMIZED
		jne	.processed
		invoke ShowWindow,[hwnddlg],SW_HIDE
		invoke Shell_NotifyIcon,NIM_ADD,note
		jmp	.processed
		
		.wmshellnotify:
		cmp	[wparam],IDI_TRAY
		jne	.processed
		cmp	[lparam],WM_LBUTTONDOWN
		jne	.processed
		invoke	ShowWindow,[hwnddlg],SW_RESTORE
		;invoke	SetActiveWindow,[hwnddlg]
		invoke	SetForegroundWindow,[hwnddlg]
		;invoke	ShowWindow,[hwnddlg],SW_MAXIMIZE
		invoke	Shell_NotifyIcon,NIM_DELETE,note
		jmp	.processed
		
		.wminitdialog:
		;GetProcessVersion
		;GetVersionOfFile
		;invoke	CheckRadioButton,[hwnddlg],ID_TEST,ID_START,ID_TEST
		;invoke	GetWindow,[hwnddlg],GW_HWNDFIRST
		;invoke GetWindowText,eax,buf,512
		;invoke	MessageBoxA,[hwnddlg],buf,buf,0
		
		invoke	LoadIcon,[hInstance],17
		mov	[hIcon],eax
		invoke	SendMessage,[hwnddlg],WM_SETICON,ICON_BIG,eax
		
		mov [note.cbSize],sizeof.NOTIFYICONDATA

        m2m	[note.hWnd],[hwnddlg]
		mov [note.uID],IDI_TRAY
		mov [note.uFlags],NIF_ICON+NIF_MESSAGE+NIF_TIP

		mov [note.uCallbackMessage],WM_SHELLNOTIFY
		m2m [note.hIcon],[hIcon]
		invoke lstrcpy,note.szTip,AppName
		jmp	.processed
		
		.wmclose:
		invoke	EndDialog,[hwnddlg],0
		.processed:
		mov	eax,1
		.finish:
		pop	edi esi ebx
		ret
	endp
	
	proc Inject lpFileName,istest
		locals
			len				dd	?
			lpThreadId		dd	?
			lpBuf			dd	?
			heax			dd	?
			hMutex			dd	?
			hReg			dd	?
		endl
		
		;	load settings for this program
		invoke	LocalAlloc,LMEM_FIXED,512
		mov		[hReg],eax
		invoke	LocalAlloc,LMEM_FIXED,512
		mov		[lpBuf],eax
		invoke	lstrcpy,[hReg],"regedit /s "
		invoke	GetModuleFileName,[hInstance],[lpBuf],512
		xor		al,al
		mov		ecx,512
		mov		edi,[lpBuf]
		cld
		repne	scasb
		dec		edi
		dec		edi
		mov		al,"\"
		mov		ecx,512
		std
		repne	scasb
		inc		edi
		inc		edi
		xor		al,al
		mov		[edi],al
		mov		ecx,512
		mov		edi,[lpFileName]
		cld
		repne	scasb
		dec		edi
		dec		edi
		mov		al,"\"
		mov		ecx,512
		std
		repne	scasb
		inc		edi
		inc		edi
		cld
		invoke	lstrcat,[lpBuf],edi
		invoke	lstrcat,[hReg],[lpBuf]
		xor		al,al
		mov		edi,[hReg]
		mov		ecx,512
		cld
		repne	scasb
		sub		edi,5
		mov		eax,".reg"
		mov		[edi],eax
		invoke	WinExec,[hReg],SW_MINIMIZE
		invoke	LocalFree,[hReg]
		invoke	LocalFree,[lpBuf]
		;invoke	ExitProcess,0
		;	full path eax.dll
		invoke	LocalAlloc,LMEM_FIXED,512
		mov		[lpBuf],eax
		
		;.if	[istest] = 0
		;	invoke	CreateMutex,NULL,TRUE,"eaxdllstart"
		;.else
		;	invoke	CreateMutex,NULL,TRUE,"eaxdlltest"
		;.endif
		;mov		[hMutex],eax
		
		invoke	LoadLibraryA,"eax.dll"
		mov		[heax],eax
		invoke	GetModuleFileName,eax,[lpBuf],512
		;invoke	ReleaseMutex,[hMutex]
		invoke	CloseHandle,[hMutex]
		
		; create suspended process
		invoke	CreateProcess,NULL,[lpFileName],NULL,NULL,FALSE,\
			CREATE_SUSPENDED,NULL,NULL,StartInfo,ProcessInfo
			
		;	 
		invoke	lstrlenA,[lpBuf]
		mov		[len],eax
		invoke	VirtualAllocEx,[ProcessInfo.hProcess],0,eax,$1000,$4
		push	eax
		stdcall	PatchProcessEx,[ProcessInfo.hProcess],eax,[len],[lpBuf]
		pop		eax
		lea		ebx,[lpThreadId]
		invoke	CreateRemoteThread,[ProcessInfo.hProcess],0,0,[LoadLibraryA],eax,0,ebx
		invoke	WaitForSingleObject,eax,INFINITE
		invoke	ResumeThread,[ProcessInfo.hThread]
		invoke	LocalFree,[lpBuf]
		
		ret
	endp
	
	proc PatchProcessEx hProcess,address,sizepatch,lpPatch
		locals
			lpflOldProtect	dd	?
		endl
		
		lea	eax,[lpflOldProtect]
		invoke	VirtualProtectEx,[hProcess],[address],[sizepatch],PAGE_READWRITE,eax
		invoke	WriteProcessMemory,[hProcess],[address],\
			[lpPatch],[sizepatch],NumberOfBytesRead
		lea	eax,[lpflOldProtect]
		invoke	VirtualProtectEx,[hProcess],[address],[sizepatch],[lpflOldProtect],eax
		
		ret
	endp
	
.end	start

section '.rsrc' resource from 'AntiCD.res' data readable
	